diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/test/wifi-aggregation-test.cc ns-3.41/src/wifi/test/wifi-aggregation-test.cc
--- ns-3.40/src/wifi/test/wifi-aggregation-test.cc	2023-09-27 13:30:37.922839900 -0700
+++ ns-3.41/src/wifi/test/wifi-aggregation-test.cc	2024-02-09 14:44:08.609795000 -0800
@@ -17,15 +17,18 @@
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
 
+#include "ns3/eht-configuration.h"
 #include "ns3/fcfs-wifi-queue-scheduler.h"
 #include "ns3/he-configuration.h"
 #include "ns3/ht-configuration.h"
 #include "ns3/ht-frame-exchange-manager.h"
 #include "ns3/interference-helper.h"
 #include "ns3/mac-tx-middle.h"
+#include "ns3/mgt-action-headers.h"
 #include "ns3/mobility-helper.h"
 #include "ns3/mpdu-aggregator.h"
 #include "ns3/msdu-aggregator.h"
+#include "ns3/multi-link-element.h"
 #include "ns3/node-container.h"
 #include "ns3/packet-socket-client.h"
 #include "ns3/packet-socket-helper.h"
@@ -47,6 +50,7 @@
 
 #include <algorithm>
 #include <iterator>
+#include <vector>
 
 using namespace ns3;
 
@@ -61,6 +65,59 @@
   public:
     AmpduAggregationTest();
 
+    /// Test parameters
+    struct Params
+    {
+        WifiStandard standard; //!< the standard of the device
+        uint8_t nLinks;        //!< number of links (>1 only for EHT)
+        std::string dataMode;  //!< data mode
+        uint16_t bufferSize;   //!< the size (in number of MPDUs) of the BlockAck buffer
+        uint16_t maxAmsduSize; //!< maximum A-MSDU size (bytes)
+        uint32_t maxAmpduSize; //!< maximum A-MPDU size (bytes)
+        Time txopLimit;        //!< TXOP limit duration
+    };
+
+    /**
+     * Construct object with non-default test parameters
+     *
+     * \param name the name of the test case
+     * \param params the test parameters
+     */
+    AmpduAggregationTest(const std::string& name, const Params& params);
+
+  protected:
+    /**
+     * Establish a BlockAck agreement.
+     *
+     * \param recipient the recipient MAC address
+     */
+    void EstablishAgreement(const Mac48Address& recipient);
+
+    /**
+     * Enqueue the given number of packets addressed to the given station and of the given size.
+     *
+     * \param count the number of packets
+     * \param size the size (bytes) of each packet
+     * \param dest the destination address
+     */
+    void EnqueuePkts(std::size_t count, uint32_t size, const Mac48Address& dest);
+
+    /**
+     * \return the Best Effort QosTxop
+     */
+    Ptr<QosTxop> GetBeQueue() const;
+
+    /**
+     * Dequeue a PSDU.
+     *
+     * \param mpduList the MPDUs contained in the PSDU
+     */
+    void DequeueMpdus(const std::vector<Ptr<WifiMpdu>>& mpduList);
+
+    Ptr<StaWifiMac> m_mac;            ///< Mac
+    std::vector<Ptr<WifiPhy>> m_phys; ///< Phys
+    Params m_params;                  //!< test parameters
+
   private:
     /**
      * Fired when the MAC discards an MPDU.
@@ -70,17 +127,31 @@
      */
     void MpduDiscarded(WifiMacDropReason reason, Ptr<const WifiMpdu> mpdu);
 
+    void DoSetup() override;
     void DoRun() override;
-    Ptr<WifiNetDevice> m_device;             ///< WifiNetDevice
-    Ptr<StaWifiMac> m_mac;                   ///< Mac
-    Ptr<YansWifiPhy> m_phy;                  ///< Phy
-    Ptr<WifiRemoteStationManager> m_manager; ///< remote station manager
-    ObjectFactory m_factory;                 ///< factory
-    bool m_discarded;                        ///< whether the packet should be discarded
+    void DoTeardown() override;
+
+    Ptr<WifiNetDevice> m_device;                           ///< WifiNetDevice
+    std::vector<Ptr<WifiRemoteStationManager>> m_managers; ///< remote station managers
+    ObjectFactory m_factory;                               ///< factory
+    bool m_discarded; ///< whether the packet should be discarded
 };
 
 AmpduAggregationTest::AmpduAggregationTest()
-    : TestCase("Check the correctness of MPDU aggregation operations"),
+    : AmpduAggregationTest("Check the correctness of MPDU aggregation operations",
+                           Params{.standard = WIFI_STANDARD_80211n,
+                                  .nLinks = 1,
+                                  .dataMode = "HtMcs7",
+                                  .bufferSize = 64,
+                                  .maxAmsduSize = 0,
+                                  .maxAmpduSize = 65535,
+                                  .txopLimit = Seconds(0)})
+{
+}
+
+AmpduAggregationTest::AmpduAggregationTest(const std::string& name, const Params& params)
+    : TestCase(name),
+      m_params(params),
       m_discarded(false)
 {
 }
@@ -92,88 +163,187 @@
 }
 
 void
-AmpduAggregationTest::DoRun()
+AmpduAggregationTest::DoSetup()
 {
     /*
      * Create device and attach HT configuration.
      */
     m_device = CreateObject<WifiNetDevice>();
-    Ptr<HtConfiguration> htConfiguration = CreateObject<HtConfiguration>();
+    m_device->SetStandard(m_params.standard);
+    auto htConfiguration = CreateObject<HtConfiguration>();
     m_device->SetHtConfiguration(htConfiguration);
+    if (m_params.standard >= WIFI_STANDARD_80211ax)
+    {
+        auto vhtConfiguration = CreateObject<VhtConfiguration>();
+        m_device->SetVhtConfiguration(vhtConfiguration);
+        auto heConfiguration = CreateObject<HeConfiguration>();
+        m_device->SetHeConfiguration(heConfiguration);
+    }
+    if (m_params.standard >= WIFI_STANDARD_80211be)
+    {
+        auto ehtConfiguration = CreateObject<EhtConfiguration>();
+        m_device->SetEhtConfiguration(ehtConfiguration);
+    }
 
     /*
      * Create and configure phy layer.
      */
-    m_phy = CreateObject<YansWifiPhy>();
-    Ptr<InterferenceHelper> interferenceHelper = CreateObject<InterferenceHelper>();
-    m_phy->SetInterferenceHelper(interferenceHelper);
-    m_phy->SetDevice(m_device);
-    m_phy->ConfigureStandard(WIFI_STANDARD_80211n);
-    m_device->SetPhy(m_phy);
+    for (uint8_t i = 0; i < m_params.nLinks; i++)
+    {
+        m_phys.emplace_back(CreateObject<YansWifiPhy>());
+        auto interferenceHelper = CreateObject<InterferenceHelper>();
+        m_phys.back()->SetInterferenceHelper(interferenceHelper);
+        m_phys.back()->SetDevice(m_device);
+        m_phys.back()->ConfigureStandard(m_params.standard);
+    }
+    m_device->SetPhys(m_phys);
 
     /*
      * Create and configure manager.
      */
     m_factory = ObjectFactory();
     m_factory.SetTypeId("ns3::ConstantRateWifiManager");
-    m_factory.Set("DataMode", StringValue("HtMcs7"));
-    m_manager = m_factory.Create<WifiRemoteStationManager>();
-    m_manager->SetupPhy(m_phy);
-    m_device->SetRemoteStationManager(m_manager);
+    m_factory.Set("DataMode", StringValue(m_params.dataMode));
+    for (uint8_t i = 0; i < m_params.nLinks; i++)
+    {
+        m_managers.emplace_back(m_factory.Create<WifiRemoteStationManager>());
+        m_managers.back()->SetupPhy(m_phys.at(i));
+    }
+    m_device->SetRemoteStationManagers(m_managers);
 
     /*
      * Create and configure mac layer.
      */
     m_mac = CreateObjectWithAttributes<StaWifiMac>("QosSupported", BooleanValue(true));
     m_mac->SetDevice(m_device);
-    m_mac->SetWifiRemoteStationManager(m_manager);
+    m_mac->SetWifiRemoteStationManagers(m_managers);
+    for (uint8_t i = 0; i < m_params.nLinks; i++)
+    {
+        m_managers.at(i)->SetupMac(m_mac);
+    }
     m_mac->SetAddress(Mac48Address("00:00:00:00:00:01"));
-    m_mac->SetWifiPhys({m_phy});
-    m_mac->ConfigureStandard(WIFI_STANDARD_80211n);
-    Ptr<FrameExchangeManager> fem = m_mac->GetFrameExchangeManager();
-    Ptr<WifiProtectionManager> protectionManager = CreateObject<WifiDefaultProtectionManager>();
-    protectionManager->SetWifiMac(m_mac);
-    fem->SetProtectionManager(protectionManager);
-    Ptr<WifiAckManager> ackManager = CreateObject<WifiDefaultAckManager>();
-    ackManager->SetWifiMac(m_mac);
-    fem->SetAckManager(ackManager);
     m_device->SetMac(m_mac);
+    m_mac->SetWifiPhys(m_phys);
+    m_mac->ConfigureStandard(m_params.standard);
+    for (uint8_t i = 0; i < m_params.nLinks; i++)
+    {
+        auto fem = m_mac->GetFrameExchangeManager(i);
+        auto protectionManager = CreateObject<WifiDefaultProtectionManager>();
+        protectionManager->SetWifiMac(m_mac);
+        fem->SetProtectionManager(protectionManager);
+        auto ackManager = CreateObject<WifiDefaultAckManager>();
+        ackManager->SetWifiMac(m_mac);
+        fem->SetAckManager(ackManager);
+        // here we should assign link addresses in case of MLDs, but we don't actually use link
+        // addresses in this test
+    }
     m_mac->SetState(StaWifiMac::ASSOCIATED);
+    if (m_params.nLinks > 1)
+    {
+        // the bssid field of StaLinkEntity must hold a value
+        for (const auto& [id, link] : m_mac->GetLinks())
+        {
+            static_cast<StaWifiMac::StaLinkEntity&>(*link).bssid = Mac48Address::GetBroadcast();
+        }
+    }
     m_mac->SetMacQueueScheduler(CreateObject<FcfsWifiQueueScheduler>());
 
     /*
-     * Configure MPDU aggregation.
+     * Configure A-MSDU and A-MPDU aggregation.
      */
-    m_mac->SetAttribute("BE_MaxAmpduSize", UintegerValue(65535));
-    HtCapabilities htCapabilities;
-    htCapabilities.SetMaxAmpduLength(65535);
-    m_manager->AddStationHtCapabilities(Mac48Address("00:00:00:00:00:02"), htCapabilities);
-    m_manager->AddStationHtCapabilities(Mac48Address("00:00:00:00:00:03"), htCapabilities);
+    // Make sure that at least 1024 MPDUs are buffered (to test aggregation on EHT devices)
+    m_mac->GetTxopQueue(AC_BE)->SetAttribute("MaxSize", StringValue("2000p"));
+    m_mac->SetAttribute("BE_MaxAmsduSize", UintegerValue(m_params.maxAmsduSize));
+    m_mac->SetAttribute("BE_MaxAmpduSize", UintegerValue(m_params.maxAmpduSize));
+    GetBeQueue()->SetAttribute(
+        "TxopLimits",
+        AttributeContainerValue<TimeValue>(std::vector<Time>(m_params.nLinks, m_params.txopLimit)));
 
-    /*
-     * Create a dummy packet of 1500 bytes and fill mac header fields.
-     */
-    Ptr<const Packet> pkt = Create<Packet>(1500);
-    Ptr<Packet> currentAggregatedPacket = Create<Packet>();
-    WifiMacHeader hdr;
-    hdr.SetAddr1(Mac48Address("00:00:00:00:00:02"));
-    hdr.SetAddr2(Mac48Address("00:00:00:00:00:01"));
-    hdr.SetType(WIFI_MAC_QOSDATA);
-    hdr.SetQosTid(0);
-    hdr.SetFragmentNumber(0);
-    hdr.SetNoMoreFragments();
-    hdr.SetNoRetry();
+    if (m_params.nLinks > 1)
+    {
+        auto mleCommonInfo2 = std::make_shared<CommonInfoBasicMle>();
+        mleCommonInfo2->m_mldMacAddress = Mac48Address("00:00:00:00:00:02");
+        for (uint8_t i = 0; i < m_params.nLinks; i++)
+        {
+            // we don't actually use the link addresses of the receiver, so we just use one address
+            // as both the MLD address and the link address of the receiver (the first argument in
+            // the call below should be the link address)
+            m_managers.at(i)->AddStationMleCommonInfo(mleCommonInfo2->m_mldMacAddress,
+                                                      mleCommonInfo2);
+        }
+
+        auto mleCommonInfo3 = std::make_shared<CommonInfoBasicMle>();
+        mleCommonInfo3->m_mldMacAddress = Mac48Address("00:00:00:00:00:03");
+        for (uint8_t i = 0; i < m_params.nLinks; i++)
+        {
+            m_managers.at(i)->AddStationMleCommonInfo(mleCommonInfo3->m_mldMacAddress,
+                                                      mleCommonInfo3);
+        }
+    }
+
+    for (uint8_t i = 0; i < m_params.nLinks; i++)
+    {
+        HtCapabilities htCapabilities;
+        htCapabilities.SetMaxAmsduLength(7935);
+        htCapabilities.SetMaxAmpduLength(65535);
+        m_managers.at(i)->AddStationHtCapabilities(Mac48Address("00:00:00:00:00:02"),
+                                                   htCapabilities);
+        m_managers.at(i)->AddStationHtCapabilities(Mac48Address("00:00:00:00:00:03"),
+                                                   htCapabilities);
+
+        if (m_params.standard >= WIFI_STANDARD_80211ac)
+        {
+            VhtCapabilities vhtCapabilities;
+            vhtCapabilities.SetMaxMpduLength(11454);
+            m_managers.at(i)->AddStationVhtCapabilities(Mac48Address("00:00:00:00:00:02"),
+                                                        vhtCapabilities);
+        }
+        if (m_params.standard >= WIFI_STANDARD_80211ax)
+        {
+            HeCapabilities heCapabilities;
+            heCapabilities.SetMaxAmpduLength((1 << 23) - 1);
+            m_managers.at(i)->AddStationHeCapabilities(Mac48Address("00:00:00:00:00:02"),
+                                                       heCapabilities);
+        }
+        if (m_params.standard >= WIFI_STANDARD_80211be)
+        {
+            EhtCapabilities ehtCapabilities;
+            ehtCapabilities.SetMaxMpduLength(11454);
+            ehtCapabilities.SetMaxAmpduLength((1 << 24) - 1);
+            m_managers.at(i)->AddStationEhtCapabilities(Mac48Address("00:00:00:00:00:02"),
+                                                        ehtCapabilities);
+        }
+    }
 
     /*
      * Establish agreement.
      */
+    EstablishAgreement(Mac48Address("00:00:00:00:00:02"));
+}
+
+Ptr<QosTxop>
+AmpduAggregationTest::GetBeQueue() const
+{
+    return m_mac->GetBEQueue();
+}
+
+void
+AmpduAggregationTest::DequeueMpdus(const std::vector<Ptr<WifiMpdu>>& mpduList)
+{
+    std::list<Ptr<const WifiMpdu>> mpdus(mpduList.cbegin(), mpduList.cend());
+    m_mac->GetTxopQueue(AC_BE)->DequeueIfQueued(mpdus);
+}
+
+void
+AmpduAggregationTest::EstablishAgreement(const Mac48Address& recipient)
+{
     MgtAddBaRequestHeader reqHdr;
     reqHdr.SetImmediateBlockAck();
     reqHdr.SetTid(0);
-    reqHdr.SetBufferSize(64);
+    reqHdr.SetBufferSize(m_params.bufferSize);
     reqHdr.SetTimeout(0);
     reqHdr.SetStartingSequence(0);
-    m_mac->GetBEQueue()->GetBaManager()->CreateOriginatorAgreement(reqHdr, hdr.GetAddr1());
+    GetBeQueue()->GetBaManager()->CreateOriginatorAgreement(reqHdr, recipient);
 
     MgtAddBaResponseHeader respHdr;
     StatusCode code;
@@ -182,27 +352,49 @@
     respHdr.SetAmsduSupport(reqHdr.IsAmsduSupported());
     respHdr.SetImmediateBlockAck();
     respHdr.SetTid(reqHdr.GetTid());
-    respHdr.SetBufferSize(64);
+    respHdr.SetBufferSize(m_params.bufferSize);
     respHdr.SetTimeout(reqHdr.GetTimeout());
-    m_mac->GetBEQueue()->GetBaManager()->UpdateOriginatorAgreement(respHdr, hdr.GetAddr1(), 0);
+    GetBeQueue()->GetBaManager()->UpdateOriginatorAgreement(respHdr, recipient, 0);
+}
+
+void
+AmpduAggregationTest::EnqueuePkts(std::size_t count, uint32_t size, const Mac48Address& dest)
+{
+    for (std::size_t i = 0; i < count; i++)
+    {
+        auto pkt = Create<Packet>(size);
+        WifiMacHeader hdr;
+
+        hdr.SetAddr1(dest);
+        hdr.SetAddr2(Mac48Address("00:00:00:00:00:01"));
+        hdr.SetType(WIFI_MAC_QOSDATA);
+        hdr.SetQosTid(0);
 
-    //-----------------------------------------------------------------------------------------------------
+        GetBeQueue()->GetWifiMacQueue()->Enqueue(Create<WifiMpdu>(pkt, hdr));
+    }
+}
 
+void
+AmpduAggregationTest::DoRun()
+{
     /*
      * Test behavior when no other packets are in the queue
      */
-    Ptr<HtFrameExchangeManager> htFem = DynamicCast<HtFrameExchangeManager>(fem);
-    Ptr<MpduAggregator> mpduAggregator = htFem->GetMpduAggregator();
+    auto fem = m_mac->GetFrameExchangeManager(SINGLE_LINK_OP_ID);
+    auto htFem = DynamicCast<HtFrameExchangeManager>(fem);
+    auto mpduAggregator = htFem->GetMpduAggregator();
 
-    m_mac->GetBEQueue()->GetWifiMacQueue()->Enqueue(Create<WifiMpdu>(pkt, hdr));
+    /*
+     * Create a dummy packet of 1500 bytes and fill mac header fields.
+     */
+    EnqueuePkts(1, 1500, Mac48Address("00:00:00:00:00:02"));
 
-    Ptr<WifiMpdu> peeked = m_mac->GetBEQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
+    auto peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
     WifiTxParameters txParams;
-    txParams.m_txVector =
-        m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
-                                                              m_phy->GetChannelWidth());
-    Ptr<WifiMpdu> item =
-        m_mac->GetBEQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, Time::Min(), true);
+    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
+        peeked->GetHeader(),
+        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
+    auto item = GetBeQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, Time::Min(), true);
 
     auto mpduList = mpduAggregator->GetNextAmpdu(item, txParams, Time::Min());
 
@@ -212,40 +404,24 @@
     m_mac->m_txMiddle->SetSequenceNumberFor(&item->GetHeader());
     item->UnassignSeqNo();
 
-    //-----------------------------------------------------------------------------------------------------
+    //---------------------------------------------------------------------------------------------
 
     /*
      * Test behavior when 2 more packets are in the queue
      */
-    Ptr<const Packet> pkt1 = Create<Packet>(1500);
-    Ptr<const Packet> pkt2 = Create<Packet>(1500);
-    WifiMacHeader hdr1;
-    WifiMacHeader hdr2;
-
-    hdr1.SetAddr1(Mac48Address("00:00:00:00:00:02"));
-    hdr1.SetAddr2(Mac48Address("00:00:00:00:00:01"));
-    hdr1.SetType(WIFI_MAC_QOSDATA);
-    hdr1.SetQosTid(0);
-
-    hdr2.SetAddr1(Mac48Address("00:00:00:00:00:02"));
-    hdr2.SetAddr2(Mac48Address("00:00:00:00:00:01"));
-    hdr2.SetType(WIFI_MAC_QOSDATA);
-    hdr2.SetQosTid(0);
+    EnqueuePkts(2, 1500, Mac48Address("00:00:00:00:00:02"));
 
-    m_mac->GetBEQueue()->GetWifiMacQueue()->Enqueue(Create<WifiMpdu>(pkt1, hdr1));
-    m_mac->GetBEQueue()->GetWifiMacQueue()->Enqueue(Create<WifiMpdu>(pkt2, hdr2));
-
-    item = m_mac->GetBEQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, Time::Min(), true);
+    item = GetBeQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, Time::Min(), true);
     mpduList = mpduAggregator->GetNextAmpdu(item, txParams, Time::Min());
 
     NS_TEST_EXPECT_MSG_EQ(mpduList.empty(), false, "MPDU aggregation failed");
 
-    Ptr<WifiPsdu> psdu = Create<WifiPsdu>(mpduList);
-    htFem->DequeuePsdu(psdu);
+    auto psdu = Create<WifiPsdu>(mpduList);
+    DequeueMpdus(mpduList);
 
     NS_TEST_EXPECT_MSG_EQ(psdu->GetSize(), 4606, "A-MPDU size is not correct");
     NS_TEST_EXPECT_MSG_EQ(mpduList.size(), 3, "A-MPDU should contain 3 MPDUs");
-    NS_TEST_EXPECT_MSG_EQ(m_mac->GetBEQueue()->GetWifiMacQueue()->GetNPackets(),
+    NS_TEST_EXPECT_MSG_EQ(GetBeQueue()->GetWifiMacQueue()->GetNPackets(),
                           0,
                           "queue should be empty");
 
@@ -254,43 +430,22 @@
         NS_TEST_EXPECT_MSG_EQ(psdu->GetHeader(i).GetSequenceNumber(), i, "wrong sequence number");
     }
 
-    //-----------------------------------------------------------------------------------------------------
+    //---------------------------------------------------------------------------------------------
 
     /*
      * Test behavior when the 802.11n station and another non-QoS station are associated to the AP.
      * The AP sends an A-MPDU to the 802.11n station followed by the last retransmission of a
      * non-QoS data frame to the non-QoS station. This is used to reproduce bug 2224.
      */
-    pkt1 = Create<Packet>(1500);
-    pkt2 = Create<Packet>(1500);
-    hdr1.SetAddr1(Mac48Address("00:00:00:00:00:02"));
-    hdr1.SetAddr2(Mac48Address("00:00:00:00:00:01"));
-    hdr1.SetType(WIFI_MAC_QOSDATA);
-    hdr1.SetQosTid(0);
-    hdr1.SetSequenceNumber(3);
-    hdr2.SetAddr1(Mac48Address("00:00:00:00:00:03"));
-    hdr2.SetAddr2(Mac48Address("00:00:00:00:00:01"));
-    hdr2.SetType(WIFI_MAC_QOSDATA);
-    hdr2.SetQosTid(0);
-
-    Ptr<const Packet> pkt3 = Create<Packet>(1500);
-    WifiMacHeader hdr3;
-    hdr3.SetSequenceNumber(0);
-    hdr3.SetAddr1(Mac48Address("00:00:00:00:00:03"));
-    hdr3.SetAddr2(Mac48Address("00:00:00:00:00:01"));
-    hdr3.SetType(WIFI_MAC_QOSDATA);
-    hdr3.SetQosTid(0);
-
-    m_mac->GetBEQueue()->GetWifiMacQueue()->Enqueue(Create<WifiMpdu>(pkt1, hdr1));
-    m_mac->GetBEQueue()->GetWifiMacQueue()->Enqueue(Create<WifiMpdu>(pkt2, hdr2));
-    m_mac->GetBEQueue()->GetWifiMacQueue()->Enqueue(Create<WifiMpdu>(pkt3, hdr3));
+    EnqueuePkts(1, 1500, Mac48Address("00:00:00:00:00:02"));
+    EnqueuePkts(2, 1500, Mac48Address("00:00:00:00:00:03"));
 
-    peeked = m_mac->GetBEQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
+    peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
     txParams.Clear();
-    txParams.m_txVector =
-        m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
-                                                              m_phy->GetChannelWidth());
-    item = m_mac->GetBEQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, Time::Min(), true);
+    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
+        peeked->GetHeader(),
+        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
+    item = GetBeQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, Time::Min(), true);
 
     mpduList = mpduAggregator->GetNextAmpdu(item, txParams, Time::Min());
 
@@ -298,14 +453,14 @@
                           true,
                           "a single packet for this destination should not result in an A-MPDU");
     // dequeue the MPDU
-    htFem->DequeueMpdu(item);
+    DequeueMpdus({item});
 
-    peeked = m_mac->GetBEQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
+    peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
     txParams.Clear();
-    txParams.m_txVector =
-        m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
-                                                              m_phy->GetChannelWidth());
-    item = m_mac->GetBEQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, Time::Min(), true);
+    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
+        peeked->GetHeader(),
+        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
+    item = GetBeQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, Time::Min(), true);
 
     mpduList = mpduAggregator->GetNextAmpdu(item, txParams, Time::Min());
 
@@ -313,25 +468,31 @@
                           true,
                           "no MPDU aggregation should be performed if there is no agreement");
 
-    m_manager->SetMaxSsrc(
-        0); // set to 0 in order to fake that the maximum number of retries has been reached
+    m_managers.at(SINGLE_LINK_OP_ID)
+        ->SetMaxSsrc(
+            0); // set to 0 in order to fake that the maximum number of retries has been reached
     m_mac->TraceConnectWithoutContext("DroppedMpdu",
                                       MakeCallback(&AmpduAggregationTest::MpduDiscarded, this));
-    htFem->m_dcf = m_mac->GetBEQueue();
+    htFem->m_dcf = GetBeQueue();
     htFem->NormalAckTimeout(item, txParams.m_txVector);
 
     NS_TEST_EXPECT_MSG_EQ(m_discarded, true, "packet should be discarded");
-    m_mac->GetBEQueue()->GetWifiMacQueue()->Flush();
+    GetBeQueue()->GetWifiMacQueue()->Flush();
+}
 
+void
+AmpduAggregationTest::DoTeardown()
+{
     Simulator::Destroy();
 
-    m_manager->Dispose();
-    m_manager = nullptr;
+    for (auto manager : m_managers)
+    {
+        manager->Dispose();
+    }
+    m_managers.clear();
 
     m_device->Dispose();
     m_device = nullptr;
-
-    htConfiguration = nullptr;
 }
 
 /**
@@ -340,22 +501,24 @@
  *
  * \brief Two Level Aggregation Test
  */
-class TwoLevelAggregationTest : public TestCase
+class TwoLevelAggregationTest : public AmpduAggregationTest
 {
   public:
     TwoLevelAggregationTest();
 
   private:
     void DoRun() override;
-    Ptr<WifiNetDevice> m_device;             ///< WifiNetDevice
-    Ptr<StaWifiMac> m_mac;                   ///< Mac
-    Ptr<YansWifiPhy> m_phy;                  ///< Phy
-    Ptr<WifiRemoteStationManager> m_manager; ///< remote station manager
-    ObjectFactory m_factory;                 ///< factory
 };
 
 TwoLevelAggregationTest::TwoLevelAggregationTest()
-    : TestCase("Check the correctness of two-level aggregation operations")
+    : AmpduAggregationTest("Check the correctness of two-level aggregation operations",
+                           Params{.standard = WIFI_STANDARD_80211n,
+                                  .nLinks = 1,
+                                  .dataMode = "HtMcs2", // 19.5Mbps
+                                  .bufferSize = 64,
+                                  .maxAmsduSize = 3050,
+                                  .maxAmpduSize = 65535,
+                                  .txopLimit = MicroSeconds(3008)})
 {
 }
 
